%% Basic linear algebra operations
%  
%  File: ccs_TP_linalg.m
%  Directory: 4_gyujtemegy/11_CCS/_1_ccs/ccs_2018/TP_2018_09_18
%  Author: Peter Polcz (ppolcz@gmail.com) 
%  
%  Created on 2018. September 18.
%
%% Subspace, image and kernel space
% Given an orthonormal basis of the image space of matrix
% 
% $$A = \pmqty{ -2 & -1 & 7 \\ -3 & -5 & 14 \\ 1 & 2 & -5 }.$$

A = [
   -2    -1     7
   -3    -5    14
    1     2    -5
    ];

%%%
% Give on orthonormal basis of the kernel (or null) space of matrix $A$.

%%%
% Give on orthonormal basis of $\rm{Im}(A)^\perp$, the orthogonal
% complement of the image space of matrix $A$.


%%%
% Give on orthonormal basis of the kernel space of matrix $A^T$.

%%%
% Given on orthonormal basis of the image space of matrix $A^T$.


%%
% Compute the singular value decomposition of matrix $A$.


%% 
% Compute the rank of diagonal matrix $S$ and matrix $A$.


%% 
% Compute the intersection of $V = \rm{Im}(A)$ and $W = \rm{Im}(A^T)$.
% Note that $V \cap W = \Big(V^\perp \cup W^\perp\Big)^\perp$

V = orth(A);
W = orth(A');


%% Partial fractional decomposition
% *Using |residue|.*
% 
% Example 1.

syms s

b_sym = s;
a_sym = s^2 + 3*s + 2;

H1_sym = b_sym/a_sym;

a = sym2poly(a_sym);
b = sym2poly(b_sym);

[r,p,k] = residue(b,a)

H1_pfrac_sym = sum(r ./ (s - p));

%%
pcz_align('H(s) = %s = %s', latex(H1_sym), latex(H1_pfrac_sym))


%%
% Example 2.

syms s

b_sym = s^3 + 3*s + 1;
a_sym = (s - 2)*(s + 3)*(s^2 + 2*s + 2)*(s^2 + 4);

H2_sym = b_sym/a_sym;

a = sym2poly(a_sym);
b = sym2poly(b_sym);

[r,p,k] = residue(b,a)

H2_pfrac_sym = vpa(sum(r ./ (s - p)),2)

%%
pcz_align('H(s) = %s = %s', latex(H2_sym), latex(H2_pfrac_sym))


%%
% *Using |partfrac|.*
% 
% Example 1.

H1_pfrac_sym = partfrac(H1_sym, s);

%%
pcz_align('H(s) = %s = %s', latex(H1_sym), latex(H1_pfrac_sym))

%%
% Example 2.

H2_pfrac_sym = partfrac(H2_sym, s, 'factormode', 'rational');

%%
pcz_align('H(s) = %s = %s', latex(H2_sym), latex(H2_pfrac_sym))

%%
H2_pfrac_sym = partfrac(H2_sym, s, 'factormode', 'real');

%%
pcz_align('H(s) = %s = %s', latex(H2_sym), latex(H2_pfrac_sym))

%%
H2_pfrac_sym = partfrac(H2_sym, s, 'factormode', 'complex');

%%
pcz_align('H(s) = %s = %s', latex(H2_sym), latex(H2_pfrac_sym))

%%
H2_pfrac_sym = partfrac(H2_sym, s, 'factormode', 'full');

%%
pcz_align('H(s) = %s = %s', latex(H2_sym), latex(H2_pfrac_sym))
